# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define _with_repolib 1

%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define repodir %{_javadir}/repository.jboss.com/org/jboss/jpa/%{name}/%{version}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free

Name:           jboss-jpa-deployers
Version:        1.0.0
Release:        1.4%{?dist}
Epoch:          0
Summary:        JBoss JPA deployers
License:        LGPLv2+
Group:          Development/Java
URL:            http://www.jboss.org/
# svn export http://anonsvn.jboss.org/repos/jbossas/projects/jpa/tags/jboss-jpa-deployers-1.0.0/
Source0:        jboss-jpa-deployers-1.0.0.tar.gz
Source1:        jboss-jpa-deployers-jpp-depmap.xml
Source2:        jboss-jpa-deployers-settings.xml
Source3:        jboss-jpa-build-1.0.0.pom
Source4:	%{name}-component-info.xml

BuildArch:      noarch
Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-deploy-plugin
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-release-plugin
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  ant-junit
BuildRequires:  codehaus-stax-api
BuildRequires:  concurrent
BuildRequires:  derby
BuildRequires:  jakarta-commons-logging
BuildRequires:  jboss-test
BuildRequires:  jbossts
BuildRequires:  junit44
BuildRequires:  slf4j-jboss-logging

#BuildRequires:  codehaus-stax11-api
BuildRequires:  hibernate3
BuildRequires:  hibernate3-entitymanager
BuildRequires:  geronimo-jta-1.1-api
BuildRequires:  jboss-common-core
BuildRequires:  jboss-deployers
BuildRequires:  jboss-integration
BuildRequires:  jboss-metadata
BuildRequires:  jboss-microcontainer2
BuildRequires:  jboss-naming
BuildRequires:  jboss-parent
BuildRequires:  jbossws
BuildRequires:  hsqldb
BuildRequires:  jboss-profiler

Requires:  java >= 0:1.5.0
Requires:  hibernate3
Requires:  hibernate3-entitymanager
Requires:  jboss-common-core
Requires:  jboss-deployers
Requires:  jboss-integration
Requires:  jboss-metadata
Requires:  jboss-microcontainer2
Requires:  jbossws

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBoss JPA deployers.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%if %{with_repolib}
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%prep
%setup -q 
%{_bindir}/find . -name "*.jar" -type f | %{_bindir}/xargs -t %{__rm} -f

cp -p %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%build
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
mkdir -p $MAVEN_REPO_LOCAL/org/jboss/jpa/jboss-jpa-build/1.0.0
cp -p %{SOURCE3} $MAVEN_REPO_LOCAL/org/jboss/jpa/jboss-jpa-build/1.0.0/jboss-jpa-build-1.0.0.pom
%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.test.skip=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -DaltDeploymentRepository=jboss-releases::default::file://$(pwd)/maven2-brew \
        install deploy:deploy javadoc:javadoc 


%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 target/%{name}-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
%add_to_maven_depmap org.jboss.jpa %{name} %{version} JPP %{name}
install -m 644 target/%{name}-%{version}-sources.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-sources.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
install -m 644 %{SOURCE3} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-jboss-jpa-build.pom
%add_to_maven_depmap org.jboss.jpa jboss-jpa-build %{version} JPP jboss-jpa-build

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -rf target/site/apidocs/* \
                  $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%if %{with_repolib}
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew

tag=`echo %{version}-brew`
sed -i "s/@VERSION@/$tag/g" %{SOURCE4}
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{SOURCE4}
install -d -m 755 $RPM_BUILD_ROOT%{repodir}
install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
install -m 755 %{SOURCE4} $RPM_BUILD_ROOT%{repodir}/component-info.xml
install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{repodirsrc}
install -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{repodirsrc}
cp -p %{SOURCE3} $RPM_BUILD_ROOT%{repodirlib}/jboss-jpa-build.pom
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar $RPM_BUILD_ROOT%{repodirlib}/%{name}.jar
cp -p pom.xml $RPM_BUILD_ROOT%{repodirlib}/%{name}.pom
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-sources.jar $RPM_BUILD_ROOT%{repodirlib}/%{name}-sources.jar
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-%{version}.jar
%{_javadir}*/%{name}.jar
%{_javadir}*/%{name}-%{version}-sources.jar
%{_javadir}*/%{name}-sources.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_datadir}/maven2/poms/JPP-jboss-jpa-build.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Tue Nov 30 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.0.0-1.4
- Build with maven 2.2.1
- Change BR maven-release to maven-release-plugin
- Add BR codehaus-stax-api, maven-deploy-plugin

* Mon May 31 2010 Permaine Cheung <pcheung@redhat.com> - 0:1.0.0-1.3.2
- Remove jboss-jpa-deployers-pom.patch as it is not needed
- depmap cleanup

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.0.0-1.3.1
- rebuilt

* Tue Apr 20 2010 Yiqiao Wang <yiwang@redhat.com> 0:1.0.0-1.3
- Rebuild
- Fix depmap entry for dtdparser, ejb3-persistence, and jbossjta
- Add BR: sun-saaj-1.3-api

* Wed Jan 27 2010 Yong Yang <yyang@redhat.com> 0:1.0.0-1.2.1
- BRs:  glassfish-jaxws, hsqldb, codehaus-stax11-api
- Comment BR jbossws
- Update depmaps 

* Fri Nov 27 2009 Martha Benitez <mbenitez@redhat.com> 0:1.0.0-1.2
- Add repolib
- Add sources.jar
- Add component-info.xml
- Comment BR codehaus-stax-api

* Thu Aug 20 2009 David Walluck <dwalluck@redhat.com> 0:1.0.0-1.1
- update for maven

* Wed Jun 24 2009 Ralph Apel <r.apel@r-apel.de> - 0:1.0.0-1.jpp5
- first release
